
function ConfigAuditCtrl($location, $scope, config, ConfigAudit)
{
	$scope.config = config;

	// Filter
	$scope.filter = {
		action:   validString($location.search().action),
		user:     validString($location.search().user),
		contains: validString($location.search().contains)
	};
	
	$scope.applyFilters = function() {
		$location.search({
			page:        1,
			action:   $scope.filter.action,
			user:     $scope.filter.user,
			contains: $scope.filter.contains
		});
	}
	
	// On page change, reload
	$scope.pageChanged = function(newPage) {
		$location.search('page', newPage);
	};

	// Set timer to trigger autorefresh
	$scope.autoRefresh = setInterval(function() {
		var filter = $location.search();
		filter.page = $scope.config.page;
    	$scope.config = Configuration.query(filter);
	}, REFRESH_INTERVAL);
	$scope.$on('$destroy', function() {
		clearInterval($scope.autoRefresh);
	});
}

ConfigAuditCtrl.resolve = {
	config: function ($rootScope, $location, $route, $q, ConfigAudit) {
    	loading($rootScope);
    	
    	var deferred = $q.defer();

    	ConfigAudit.query($location.search(),
  			  genericSuccessMethod(deferred, $rootScope),
			  genericFailureMethod(deferred, $rootScope, $location));
    	
    	return deferred.promise;
	}
}


function ConfigStatusCtrl($location, $scope, server, links, debug)
{
	$scope.server = server;
	$scope.links = links;
	$scope.debug = debug;
	
	// On page change, reload
	$scope.pageChanged = function(newPage) {
		$location.search('page', newPage);
	};
}

ConfigStatusCtrl.resolve = {
	server: function ($rootScope, $location, $route, $q, ConfigServer) {
		loading($rootScope);
		
		var deferred = $q.defer();
		
		ConfigServer.all(
  			  genericSuccessMethod(deferred, $rootScope),
			  genericFailureMethod(deferred, $rootScope, $location));

		return deferred.promise;
	},
	
	links: function($rootScope, $location, $route, $q, ConfigLinks) {
		loading($rootScope);
		
		var deferred = $q.defer();
		
		ConfigLinks.query($location.search(),
  			  genericSuccessMethod(deferred, $rootScope),
			  genericFailureMethod(deferred, $rootScope, $location));
		
		return deferred.promise;
	},
	
	debug: function($rootScope, $location, $route, $q, ConfigDebug) {
		loading($rootScope);
		
		var deferred = $q.defer();
		
		ConfigDebug.query(
  			  genericSuccessMethod(deferred, $rootScope),
			  genericFailureMethod(deferred, $rootScope, $location));
		
		return deferred.promise;
	}
}
